//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DatePortuguese.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
namespace ipt{
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
DatePortuguese::DatePortuguese():Date()
{
}

DatePortuguese::DatePortuguese(const DatePortuguese& other):
   Date(other)
{
}

DatePortuguese::DatePortuguese(const Date& other):
   Date(other)
{
}

DatePortuguese::DatePortuguese(int year, int month, int day):
 Date(year, month, day)
{
}

DatePortuguese::~DatePortuguese()
{
}


bool DatePortuguese::Holiday() const
{
  return (NewYear() || Liberty () || Workers() ||
          Nation() || Assumption() || Republic() ||
          AllSaints() || Independence() || OurLady() ||
          Christmas() || Carnival() || GoodFriday() ||
          Easter() || CorpusChristi());
}

bool DatePortuguese::NewYear() const
{
  return operator==(NewYear(Year()));
}
bool DatePortuguese::Liberty() const
{
  return operator==(Liberty(Year()));
}
bool DatePortuguese::Workers() const
{
  return operator==(Workers(Year()));
}
bool DatePortuguese::Nation() const
{
  return operator==(Nation(Year()));
}
bool DatePortuguese::Assumption() const
{
  return operator==(Assumption(Year()));
}
bool DatePortuguese::Republic() const
{
  return operator==(Republic(Year()));
}
bool DatePortuguese::AllSaints() const
{
  return operator==(AllSaints(Year()));
}
bool DatePortuguese::Independence() const
{
  return operator==(Independence(Year()));
}
bool DatePortuguese::OurLady() const
{
  return operator==(OurLady(Year()));
}
bool DatePortuguese::Christmas() const
{
  return operator==(Christmas(Year()));
}
bool DatePortuguese::Carnival() const
{
  return operator==(Carnival(Year()));
}
bool DatePortuguese::GoodFriday() const
{
  return operator==(GoodFriday(Year()));
}
bool DatePortuguese::Easter() const
{
  return operator==(Easter(Year()));
}
bool DatePortuguese::CorpusChristi() const
{
  return operator==(CorpusChristi(Year()));
}
//---------------------------------------------------------------------------
bool DatePortuguese::Primavera() const
{
  return operator==(Primavera(Year()));
}
bool DatePortuguese::Verao() const
{
  return operator==(Verao(Year()));
}
bool DatePortuguese::Outono() const
{
  return operator==(Outono(Year()));
}
bool DatePortuguese::Inverno() const
{
  return operator==(Inverno(Year()));
}
//---------------------------------------------------------------------------
DatePortuguese DatePortuguese::NewYear(int y)
{
  return DatePortuguese(y,1,1);
}
DatePortuguese DatePortuguese::Liberty(int y)
{
  return DatePortuguese(y,4,25);
}
DatePortuguese DatePortuguese::Workers(int y)
{
  return DatePortuguese(y,5,1);
}
DatePortuguese DatePortuguese::Nation(int y)
{
  return DatePortuguese(y,6,10);
}
DatePortuguese DatePortuguese::Assumption(int y)
{
  return DatePortuguese(y,8,15);
}
DatePortuguese DatePortuguese::Republic(int y)
{
  return DatePortuguese(y,10,5);
}
DatePortuguese DatePortuguese::AllSaints(int y)
{
  return DatePortuguese(y,11,1);
}
DatePortuguese DatePortuguese::Independence(int y)
{
  return DatePortuguese(y,12,1);
}
DatePortuguese DatePortuguese::OurLady(int y)
{
  return DatePortuguese(y,12,8);
}
DatePortuguese DatePortuguese::Christmas(int y)
{
  return DatePortuguese(y,12,25);
}
DatePortuguese DatePortuguese::Carnival(int y)
{
  return Easter(y)-47;
}
DatePortuguese DatePortuguese::GoodFriday(int y)
{
  return Easter(y)-2;
}

DatePortuguese DatePortuguese::CorpusChristi(int y)
{
  return Easter(y)+60;
}

DatePortuguese DatePortuguese::Easter(int y)
{
  int a = y % 19;
  int b = y / 100;
  int c = y % 100;
  int d = b / 4;
  int e = b % 4;
  int f = ( b + 8 ) / 25;
  int g = ( b - f + 1 ) / 3;
  int h = ( 19 * a + b - d - g + 15) % 30;
  int i = c / 4;
  int k = c % 4;
  int l = ( 32 + 2 * e + 2 * i - h - k ) % 7;
  int m = ( a + 11 * h + 22 * l) / 451;
  int n = h + 1 - 7 * m + 114;
  DatePortuguese result(y, n / 31, n % 31 + 1);
  result--;
  result.ReachForward(SUNDAY);
  return result;
}

//---------------------------------------------------------------------------
DatePortuguese DatePortuguese::Primavera(int y)
{
  return DatePortuguese(y,3,20);
}

DatePortuguese DatePortuguese::Verao(int y)
{
  return DatePortuguese(y,6,21);
}

DatePortuguese DatePortuguese::Outono(int y)
{
  return DatePortuguese(y,9,22);
}

DatePortuguese DatePortuguese::Inverno(int y)
{
  return DatePortuguese(y,12,21);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
}
