//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "VisualCalendar.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#include "DatePortuguese.h"
#include "Point2D.h"
//---------------------------------------------------------------------------
VisualCalendar::VisualCalendar(int month, int year, TImage *img):
   month(month),
   year(year),
   img(img)
{
  CalculateMatrix();
}
//---------------------------------------------------------------------------
VisualCalendar::~VisualCalendar()
{
}

void VisualCalendar::CalculateMatrix()
{
  using namespace ipt;
  DatePortuguese d(year,month,1);
  d.ReachBackward(Date::MONDAY);
  double x0 = (img->Width-1) /8.0 /1.6;
  double dx = ((img->Width-1)-x0) /7.0;
  double y0 = (img->Height-1) /7.0 /1.4;
  double dy = ((img->Height-1)-y0) /6.0;

  matrix[0][0].SetStr1("S");
  matrix[0][1].SetStr1("SEG");
  matrix[0][2].SetStr1("TER");
  matrix[0][3].SetStr1("QUA");
  matrix[0][4].SetStr1("QUI");
  matrix[0][5].SetStr1("SEX");
  matrix[0][6].SetStr1("SB");
  matrix[0][7].SetStr1("DOM");

  for(int y=0; y< 7; y++)
    for( int x=0; x<8; x++)
    {
       if (x==0 || y==0)
       {
          matrix[y][x].SetBrushColor(clWhite);
          if (x==0 && y==0)
          {
          matrix[0][0].SetTipe(5);
          matrix[0][0].Set(Point2D( 0 , 0 ),0);
          matrix[0][0].Set(Point2D( x0 , 0 ),1);
          matrix[0][0].Set(Point2D( x0 , y0 ),2);
          matrix[0][0].Set(Point2D( 0 , y0 ),3);
          }
          if (x==0 && y>0){
          matrix[y][0].SetTipe(6);
          matrix[y][0].Set(Point2D( 0, y0+((y-1)*dy) ),0);
          matrix[y][0].Set(Point2D( x0 , y0+((y-1)*dy) ),1);
          matrix[y][0].Set(Point2D( x0 ,y0+(y*dy) ),2);
          matrix[y][0].Set(Point2D( 0 ,y0+(y*dy) ),3);
          matrix[y][0].SetDay(d.WeekNumber());
          if (d.Year()<year)
          matrix[y][0].SetDay(1);
          }
          if (y==0 && x>0){
          matrix[0][x].SetTipe(5);
          matrix[0][x].Set(Point2D( x0+((x-1)*dx) , 0 ),0);
          matrix[0][x].Set(Point2D( x0+(x*dx) , 0 ),1);
          matrix[0][x].Set(Point2D( x0+(x*dx) , y0),2);
          matrix[0][x].Set(Point2D( x0+((x-1)*dx) , y0),3);
          }
       }
       else
       {

          matrix[y][x].Set(Point2D( x0+((x-1)*dx) , y0+((y-1)*dy) ),0);
          matrix[y][x].Set(Point2D(x0+(x*dx) , y0+((y-1)*dy) ),1);
          matrix[y][x].Set(Point2D(x0+(x*dx) ,y0+(y*dy) ),2);
          matrix[y][x].Set(Point2D( x0+((x-1)*dx) ,y0+(y*dy) ),3);

          if( d.Month() != month ){
              matrix[y][x].SetBrushColor(clLtGray);
              matrix[y][x].SetTipe(0);
          }
          else
          {
              matrix[y][x].SetTipe(d.Moon());

              if( d.Weekend() )
                 matrix[y][x].SetBrushColor(clRed);

              if( d.Holiday() )
              {
              matrix[y][x].SetBrushColor(clGreen);
              if ( d.NewYear() )
              matrix[y][x].SetStr2("Ano Novo");
              if ( d.Liberty() ) {
              matrix[y][x].SetStr1("Dia da");
              matrix[y][x].SetStr2("Liberdade");
              }
              if ( d.Workers() ) {
              matrix[y][x].SetStr1("Dia do");
              matrix[y][x].SetStr2("Trabalhador");
              }
              if ( d.Nation() ) {
              matrix[y][x].SetStr1("Dia de");
              matrix[y][x].SetStr2("Portugal");
              }
              if ( d.Assumption() ) {
              matrix[y][x].SetStr1("Assuno");
              matrix[y][x].SetStr2("N Senhora");
              }
              if ( d.Republic() ) {
              matrix[y][x].SetStr1("Implantao");
              matrix[y][x].SetStr2("Republica");
              }
              if ( d.AllSaints() ) {
              matrix[y][x].SetStr1("Dia Todos");
              matrix[y][x].SetStr2("os Santos");
              }
              if ( d.Independence() ) {
              matrix[y][x].SetStr1("Restaurao");
              matrix[y][x].SetStr2("Independ.");
              }
              if ( d.OurLady() ) {
              matrix[y][x].SetStr1("Imaculada");
              matrix[y][x].SetStr2("Conceio");
              }
              if ( d.Christmas() )
              matrix[y][x].SetStr2("Natal");
              if ( d.Carnival() )
              matrix[y][x].SetStr2("Carnaval");
              if ( d.GoodFriday() ){
              matrix[y][x].SetStr1("Sexta-Feira");
              matrix[y][x].SetStr2("Santa");
              }
              if ( d.Easter() )
              matrix[y][x].SetStr2("Pscoa");
              if ( d.CorpusChristi() ) {
              matrix[y][x].SetStr1("Corpo de");
              matrix[y][x].SetStr2("Deus");
              }
              }
              if ( d.Primavera() )
              matrix[y][x].SetStr2("Primavera");
              if ( d.Verao() )
              matrix[y][x].SetStr2("Verao");
              if ( d.Outono() )
              matrix[y][x].SetStr2("Outono");
              if ( d.Inverno() )
              matrix[y][x].SetStr2("Inverno");
              if ( d==DatePortuguese() )
              matrix[y][x].SetStr2("HOJE");
          }
          matrix[y][x].SetDay( d.Day());
          d++;
       }

    }
}

void VisualCalendar::Draw()
{
  for(int y=0; y< 7; y++)
    for( int x=0; x<8; x++)
       matrix[y][x].Draw(img->Canvas);
}

