//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define dpi 3.14159265358979323846*2
#include <dos.h>
#include "VisualClock.h"
#include "VisualLine.h"
#include "VisualPolygons.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
VisualClock::VisualClock(TImage *img):
  sec(),
  min(4),
  hour(4),
  img(img)
{
sec.SetPenWidth(1);
sec.SetPenColor(clBlack);
sec.SetPenStyle(psSolid);
min.SetPenColor(clDkGray);
min.SetBrushColor(clDkGray);
hour.SetPenColor(clDkGray);
hour.SetBrushColor(clDkGray);
}
//---------------------------------------------------------------------------

VisualClock::~VisualClock()
{
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

AnsiString VisualClock::Time()
{
        TDateTime DateTime = Time();
        AnsiString str = TimeToStr(DateTime);
        return str;
}

//---------------------------------------------------------------------------
void VisualClock::Draw()
{

Point2D center((img->Width-1)/2,(img->Height-1)/2);
double d=center.DistanceTo(Point2D(center.X(),0));

struct time t;
gettime(&t);

sec.Hide(img->Canvas);
min.Hide(img->Canvas);
hour.Hide(img->Canvas);

min.Set(Point2D(center.X(),d*15/100),0);
min.Set(Point2D(center.X()-4,center.Y()),1);
min.Set(Point2D(center.X(),center.Y()+10),2);
min.Set(Point2D(center.X()+4,center.Y()),3);
min.RotateAround((dpi/60)*(int)t.ti_min,center);
min.Draw(img->Canvas);

hour.Set(Point2D(center.X(),d*30/100),0);
hour.Set(Point2D(center.X()-4,center.Y()),1);
hour.Set(Point2D(center.X(),center.Y()+10),2);
hour.Set(Point2D(center.X()+4,center.Y()),3);
hour.RotateAround((dpi/12)*(int)t.ti_hour,center);
hour.Draw(img->Canvas);

sec.Setpinicial(center);
sec.Setpfinal(Point2D (center.X(),d*10/100));
sec.RotateAround((dpi/60)*(int)t.ti_sec,center);
sec.Draw(img->Canvas);

}
//---------------------------------------------------------------------------

void VisualClock::DrawPoints()
{

Point2D center((img->Width-1)/2,(img->Height-1)/2);
VisualLine p(Point2D(center.X(),1),Point2D(center.X()+1,1));
sec.SetPenWidth(1);
sec.SetPenColor(clDkGray);
sec.SetPenStyle(psSolid);
for (int i=0;i<12;i++){
p.RotateAround((dpi/12)*i,center);
p.Draw(img->Canvas);
}

}
