//---------------------------------------------------------------------------

#include <dos.h>
#include <vcl.h>
#pragma hdrstop

#define dpi 3.14159265358979323846*2
#include "untCalendar.h"
#include "VisualCalendar.h"
#include "Date.h"
#include "Point2D.h"
#include "VisualLine.h"
#include "VisualPolygons.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCalendar *frmCalendar;
//---------------------------------------------------------------------------
__fastcall TfrmCalendar::TfrmCalendar(TComponent* Owner)
        : TForm(Owner)
{

ipt::Date d;
YearUpDown->Position = d.Year();
Year->Text = YearUpDown->Position;
Month->ItemIndex =d.Month()-1;
WeekUpDown->Position =d.WeekNumber();
Week->Text= WeekUpDown->Position;

//////////////////////////////////////////////////////////////
sec= VisualLine(Point2D(),Point2D());
sec.SetPenWidth(1);
sec.SetPenColor(clBlack);
sec.SetPenStyle(psSolid);
min= new VisualPolygons(4);
min->SetPenColor(clWhite);
min->SetBrushColor(/*clDkGray*/clTeal);
hour= new VisualPolygons(4);
hour->SetPenColor(clTeal);
hour->SetBrushColor(clTeal);

Point2D center((imgClock->Width-1)/2,(imgClock->Height-1)/2);

Point2D h;

int j=0;
for (int i=0;i<60;i++)
{
   Point2D aux(center.X(),2);
   aux.RotateAround(dpi*i/60,center);
   h=aux;
   if(i==j){
      j+=5;
      imgClock->Canvas->Pen->Color=/*clDkGray*/clTeal;
      imgClock->Canvas->Brush->Color=clTeal;
      imgClock->Canvas->Rectangle(h.X()-2,h.Y()-2,h.X()+2,h.Y()+2);
   }
   else {
      imgClock->Canvas->Pen->Color=clBlack;
      imgClock->Canvas->Brush->Color=clBlack;
      imgClock->Canvas->Ellipse(h.X()-1,h.Y()-1,h.X()+1,h.Y()+1);
   }
}

////////////////////////////////////////////////////////////////

}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::FormDestroy(TObject *Sender)
{
delete min;
delete hour;
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::YearUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
Year->Text = YearUpDown->Position;
Week->Text = ipt::Date (YearUpDown->Position,Month->ItemIndex+1,1).WeekNumber();
WeekUpDown->Position=Week->Text.ToInt();
FormCreate(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::MonthChange(TObject *Sender)
{

Week->Text = ipt::Date (YearUpDown->Position,Month->ItemIndex+1,1).WeekNumber();
WeekUpDown->Position=Week->Text.ToInt();
FormCreate(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::WeekUpDownClick(TObject *Sender,
      TUDBtnType Button)
{
if (WeekUpDown->Position > ipt::Date(YearUpDown->Position,12,24).WeekNumber())
WeekUpDown->Position=ipt::Date(YearUpDown->Position,12,24).WeekNumber();


Week->Text= WeekUpDown->Position;
Month->ItemIndex= ipt::Date::Month(WeekUpDown->Position,YearUpDown->Position)-1;
FormCreate(Sender);


}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::Timer1Timer(TObject *Sender)
{

Point2D center((imgClock->Width-1)/2,(imgClock->Height-1)/2);
double dt=center.DistanceTo(Point2D(center.X(),0));

struct time t;
gettime(&t);

sec.Hide(imgClock->Canvas);
min->Hide(imgClock->Canvas);
hour->Hide(imgClock->Canvas);


hour->Set(Point2D(center.X(),dt*40/100),0);
hour->Set(Point2D(center.X()-4,center.Y()),1);
hour->Set(Point2D(center.X(),center.Y()+10),2);
hour->Set(Point2D(center.X()+4,center.Y()),3);
hour->RotateAround(((dpi/12.0)*(int)t.ti_hour)+((dpi*(int)t.ti_min)/12/60),center);
hour->Draw(imgClock->Canvas);


min->Set(Point2D(center.X(),dt*14/100),0);
min->Set(Point2D(center.X()-5,center.Y()),1);
min->Set(Point2D(center.X(),center.Y()+10),2);
min->Set(Point2D(center.X()+5,center.Y()),3);
min->RotateAround((dpi/60.0)*(int)t.ti_min,center);
min->Draw(imgClock->Canvas);


sec.Setpinicial(center);
sec.Setpfinal(Point2D (center.X(),dt*10/100));
sec.RotateAround((dpi/60.0)*(int)t.ti_sec,center);
sec.Draw(imgClock->Canvas);


TDateTime DateTime = Time();
Tm->Text=TimeToStr(DateTime);

}
//---------------------------------------------------------------------------

void __fastcall TfrmCalendar::FormCreate(TObject *Sender)
{
VisualCalendar(Month->ItemIndex+1,YearUpDown->Position,imgCalendar).Draw();
if (Month->ItemIndex+1<12)
VisualCalendar(Month->ItemIndex+2,YearUpDown->Position,imgNext).Draw();
else
VisualCalendar(1,YearUpDown->Position+1,imgNext).Draw();
if (Month->ItemIndex+1>1)
VisualCalendar(Month->ItemIndex,YearUpDown->Position,imgPrevious).Draw();
else
VisualCalendar(12,YearUpDown->Position-1,imgPrevious).Draw();
}
//---------------------------------------------------------------------------


